//
// Programmer: Andrew MacKenzie
//
// Date: 
//
// Version: 
//
// Description:
//

#include <stdio.h>
#include <stdlib.h>

#include <ncurses.h>
#include <signal.h>
#include <time.h>
#include <vector>
#include <unistd.h>
#include <string>

#include "Frame.h"
#include "Util.h"

vector <char *> fileList;
vector<Frame> frameList;

FILE * ferr=NULL;

unsigned long delay;

int init()
{
    for (int i=0; i<fileList.size(); i++)
    {
        frameList.push_back( Frame(fileList[i],i, fileList.size()) );
    }

    delay=3; // Second(s)
}

void display()
{

    while(1)
    {

        for (int i=0; i<frameList.size(); i++)
        {
            //move( (LINES/frameList.size()) * i ,0); deleteln();
            frameList[i].print();
        }
    
        sleep(delay);
    }

}

int usage(string prog)
{
    printf("Usage:\n\n\t%s <file1> <file2> ...\n\n", prog.c_str());
}

int main( int argc, char ** argv )
{

    (void) signal(SIGINT, sig_int);


    time_t start, end;
    time_t tstart, tend;

    ferr = fopen("err.txt","w");
    // fudge some filenames.
    //fileList.push_back("file1");
    //fileList.push_back("file2");
    //fileList.push_back("/var/log/messages");
    //fileList.push_back("/var/log/secure");
    //fileList.push_back("/new/apache/logs/access_log");
    if ( argc > 1 )
    {

        for (int i=1; i<argc; i++)
        {
            fileList.push_back(argv[i]);
        }
    }
    else
    {
        usage(string(argv[0]));
        clean_exit();
    }

    // Initialize our ncurses window.
    initscr(); cbreak(); clear(); refresh(); 

    init();


    display();

    clean_exit();

    return 0;
}
